--[[
  ****************************************************************
	OGbarsGY
	A UI Mod which attempts to track GY timers in Battlegrounds
	
	Written by Ogdin
	http://www.atlantic-orcs.org/

	--How it works:
		--When you arrive at a BG, detect position and determine which GY you're at
		--Detect a transition between non-zero Spirit Heal Timers (reports w/ seconds resolution).
		--Broadcast this time to BG along w/ InstanceRunTime for the BG
		--Set Timer for that GY to count down.
		--Drive timer from rez to 34.3s, reset

	****************************************************************]]


-------------------------------------------------------
function GYBARS_Initialize()
	
	GYBARS={}
	GYBARSLocale={}
	GYDBF=0
	GYBARS["OLDTIME"]=0;
	GYBARS["NEWTIME"]=0;
	GYBARS["BCFLAG"]=0;
	GYBARS["CurrentGY"]=0;
	GYBARS["DEFAULTDURATION"]=33.5
	GYBARSTARGETS={} for i=1,8 do GYBARSTARGETS[i]=0 end
	GYBARSINIT={} for i=1,8 do GYBARSINIT[i]=0 end

	GYBARSLocale[" Controlled"]=" Controlled"

	--Alterac Valley
	GYBARSAV={} GYBARSAVX={} GYBARSAVY={}
	GYBARSAV={"Frostwolf Relief Hut","Frostwolf Graveyard","Iceblood Graveyard","Snowfall Graveyard","Stonehearth Graveyard","Stormpike Graveyard","Stormpike Aid Station","Alliance Entrance","Horde Entrance"}
	GYBARSAVX={0.49,0.49,0.51,0.44,0.51,0.49,0.49,0.53,0.56}
	GYBARSAVY={0.89,0.76,0.57,0.45,0.36,0.14,0.15,0.07,0.67}
	
	GYBARSAB={"Farm Graveyard","Lumbermill Graveyard","Blacksmith Graveyard","Gold Mine Graveyard","Stables Graveyard","Alliance Entrance","Horde Entrance"}
	GYBARSABT={"farm","lumber mill","blacksmith","mine","stables"}
	GYBARSABX={0.59,0.39,0.48,0.59,0.38,0.30,0.66}
	GYBARSABY={0.58,0.59,0.44,0.28,0.28,0.15,0.70}

	GYBARSWSG={"Alliance Graveyard","Horde Graveyard"}

	GYBARS["has begun"]="has begun"
	GYBARS["begin"]="begin"
	

	SlashCmdList["GYBARS"] = GYBARS_Slash;
	SLASH_GYBARS1 = "/ogbarsgy";

	this:RegisterEvent("PLAYER_ENTERING_WORLD")
	this:RegisterEvent("AREA_SPIRIT_HEALER_IN_RANGE")
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE")
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE")
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL")
	this:RegisterEvent("CHAT_MSG_MONSTER_YELL")
	this:RegisterEvent("CHAT_MSG_ADDON")

	for i=1,8 do 	getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.4,.4,.4) 
			getglobal("GYBARST"..i.."y"):SetTextColor(1,1,1,1)
			getglobal("GYBARS_T"..i.."_Front"):SetVertexColor(0,0,0,.3) end


end

function GYBARS_test()
	x,y=GetPlayerMapPosition("Player")
	DEFAULT_CHAT_FRAME:AddMessage(x.." ----- "..y)
	for i=1,GetNumMapLandmarks() do
		name, description, textureIndex, x, y = GetMapLandmarkInfo(i)
		DEFAULT_CHAT_FRAME:AddMessage(i.." "..name.." - "..description.." - "..textureIndex.." - "..x..","..y)
	end
	DEFAULT_CHAT_FRAME:AddMessage(GetBattlefieldInstanceRunTime())

end


-------------------------------------------------------
function GYBARS_OnUpdate()
	if not UnitIsDead("Player") then GYBARS["BCFLAG"]=0; end
	if GetZoneText()~="Alterac Valley" and GetZoneText()~="Arathi Basin" and GetZoneText()~="Warsong Gulch" then GYBARS_Frame:Hide() end
	if GetZoneText()=="Alterac Valley" and GYBARSINIT[8]==0 then GYBARS_Zone() end
	if GetZoneText()=="Arathi Basin" and GYBARSINIT[6]==0 then GYBARS_Zone() end
	if GetZoneText()=="Warsong Gulch" and GYBARSINIT[1]==0 then GYBARS_Zone() end

	GYBARS_minDist()

	--Update Timer Graphics
	if GetZoneText()=="Alterac Valley" then
		GYBARS_UpdateControl()
		GYTNOW=GetBattlefieldInstanceRunTime()/1000;
		j=0;
		for i=1,8 do 
			getglobal("GYBARS_Timer"..i):Show()
			if GYBARSTARGETS[i]>GYTNOW then
				getglobal("GYBARS_Timer"..i):SetPoint("LEFT",0,13*j);
				getglobal("GYBARS_T"..i.."_Front"):SetPoint("BOTTOMRIGHT",-150*(1-(GYBARSTARGETS[i]-GYTNOW)/GYBARS["DEFAULTDURATION"])*GYBARSINIT[i],0);
					GYSecs=GYBARSTARGETS[i]-GYTNOW
				getglobal("GYBARST"..i.."x"):SetText(string.format("0:%02.0f",GYSecs))
				j=j+1
			else
				GYBARSTARGETS[i]=GYTNOW+GYBARS["DEFAULTDURATION"]
				j=j+1
			end
			if i==8 then getglobal("GYBARS_Timer"..i):SetPoint("LEFT",0,-13) end
		end
	elseif GetZoneText()=="Arathi Basin" then
		GYBARS_UpdateControl()
		GYTNOW=GetBattlefieldInstanceRunTime()/1000;
		for i=1,6 do getglobal("GYBARS_Timer"..i):Show() end
		for i=7,8 do getglobal("GYBARS_Timer"..i):Hide() end
		j=0;
		for i=1,6 do 
			getglobal("GYBARS_Timer"..i):Show()
			if GYBARSTARGETS[i]>GYTNOW then
				getglobal("GYBARS_Timer"..i):SetPoint("LEFT",0,13*j);
				getglobal("GYBARS_T"..i.."_Front"):SetPoint("BOTTOMRIGHT",-150*(1-(GYBARSTARGETS[i]-GYTNOW)/GYBARS["DEFAULTDURATION"])*GYBARSINIT[i],0);
					GYSecs=GYBARSTARGETS[i]-GYTNOW
				getglobal("GYBARST"..i.."x"):SetText(string.format("0:%02.0f",GYSecs))
				j=j+1
			else
				GYBARSTARGETS[i]=GYTNOW+GYBARS["DEFAULTDURATION"]
				j=j+1
			end
			if i==6 then getglobal("GYBARS_Timer"..i):SetPoint("LEFT",0,-13) end
		end
	elseif GetZoneText()=="Warsong Gulch" then
		GYBARS_UpdateControl()
		GYTNOW=GetBattlefieldInstanceRunTime()/1000;
		GYBARS_Timer1:Show()
		for i=2,8 do getglobal("GYBARS_Timer"..i):Hide() end
		if GYBARSTARGETS[1]>GYTNOW then
			GYBARS_Timer1:SetPoint("LEFT",0,0);
			GYBARS_T1_Front:SetPoint("BOTTOMRIGHT",-150*(1-(GYBARSTARGETS[1]-GYTNOW)/GYBARS["DEFAULTDURATION"])*GYBARSINIT[1],0);
				GYSecs=GYBARSTARGETS[1]-GYTNOW
			GYBARST1x:SetText(string.format("0:%02.0f",GYSecs))
		else
			GYBARSTARGETS[1]=GYTNOW+GYBARS["DEFAULTDURATION"]
		end
	end
	--Grab Value if dead, Broadcast it to BG raid
	if GYBARS["OLDTIME"]~=0 and GetAreaSpiritHealerTime()~=GYBARS["OLDTIME"] and GYBARS["BCFLAG"]==0 and GetAreaSpiritHealerTime()~=0 then
		GYBARS_EnterGY()
		SendAddonMessage("GYBARS",GYBARS["CurrentGY"].."x"..(GetBattlefieldInstanceRunTime()/1000+GetAreaSpiritHealerTime()),"BATTLEGROUND")
		GYBARS["BCFLAG"]=1;
		GYBARSTARGETS[GYBARS["CurrentGY"]]=GetBattlefieldInstanceRunTime()/1000+GetAreaSpiritHealerTime()+1
		GYBARSINIT[GYBARS["CurrentGY"]]=1
	end
	GYBARS["OLDTIME"]=GetAreaSpiritHealerTime();
		
end

function GYBARS_ChatCatch()
	if arg1~="GYBARS" then return end
	if arg4==UnitName("Player") then return end
	_,_,GYBARS_Temp1,GYBARS_Temp2 = string.find(arg2,"(.+)x(.+)")
	GYBARS_Temp1=tonumber(GYBARS_Temp1)
	GYBARS_Temp2=tonumber(GYBARS_Temp2)
	GYBARSTARGETS[GYBARS_Temp1]=GYBARS_Temp2+1
end

function GYBARS_UpdateControl()
	--arg1 contains the message
	--Just reset the GY timer any time an event occurs with a GY name in it
	if arg1==nil then arg1="   " end

for i=1,8 do GYBARSINIT[i]=0 end
englishFaction, localizedFaction = UnitFactionGroup("Player")

if GetZoneText()=="Alterac Valley" then 
	--6 is FW, 10 is IB, 15 is SF, 17 is SH, 20 is SP,8 is FW base, 19 is SP base 
	_, description, _, _, _ = GetMapLandmarkInfo(8)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[1]=0 else GYBARSINIT[1]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(6)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[2]=0 else GYBARSINIT[2]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(10)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[3]=0 else GYBARSINIT[3]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(15)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[4]=0 else GYBARSINIT[4]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(17)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[5]=0 else GYBARSINIT[5]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(20)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[6]=0 else GYBARSINIT[6]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(19)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[7]=0 else GYBARSINIT[7]=1  end
	GYBARSINIT[8]=1
	GYBARS_Frame:Show()

	if string.find(arg1,GYBARS["has begun"]) then for i=1,8 do GYBARSTARGETS[i]=GetBattlefieldInstanceRunTime()/1000+GYBARS["DEFAULTDURATION"] end end
	for i=1,8 do if string.find(string.lower(arg1),string.lower(GYBARSAV[i])) then GYBARSTARGETS[i]=GetBattlefieldInstanceRunTime()/1000+GYBARS["DEFAULTDURATION"] end end

	if englishFaction=="Horde" then
		for i=1,8 do if GYBARSINIT[i]==1 then getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.6,.2,.2) getglobal("GYBARST"..i.."x"):Show()
			else getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.4,.4,.4) getglobal("GYBARST"..i.."x"):Hide() end end end
	if englishFaction=="Alliance" then
		for i=1,8 do if GYBARSINIT[i]==1 then getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.2,.2,.6) getglobal("GYBARST"..i.."x"):Show()
			else getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.4,.4,.4) getglobal("GYBARST"..i.."x"):Hide() end end end

	_, description, _, _, _ = GetMapLandmarkInfo(15)
	if description=="Uncontrolled" then GYBARS_T4_Back:SetVertexColor(.4,.4,.4)  end
elseif GetZoneText()=="Arathi Basin" then
	--1=Blacksmith, 2=Farm, 3=Gold Mine, 4=Lumber Mill, 5=Stables
	_, description, _, _, _ = GetMapLandmarkInfo(2)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[1]=0 else GYBARSINIT[1]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(4)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[2]=0 else GYBARSINIT[2]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(1)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[3]=0 else GYBARSINIT[3]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(3)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[4]=0 else GYBARSINIT[4]=1  end
	_, description, _, _, _ = GetMapLandmarkInfo(5)
	if description~=(localizedFaction..GYBARSLocale[" Controlled"]) then GYBARSINIT[5]=0 else GYBARSINIT[5]=1  end
	GYBARSINIT[6]=1

	if string.find(arg1,GYBARS["has begun"]) then for i=1,6 do GYBARSTARGETS[i]=GetBattlefieldInstanceRunTime()/1000+GYBARS["DEFAULTDURATION"] end end
	for i=1,5 do if string.find(string.lower(arg1),string.lower(GYBARSABT[i])) then GYBARSTARGETS[i]=GetBattlefieldInstanceRunTime()/1000+GYBARS["DEFAULTDURATION"] end end

	if englishFaction=="Horde" then
		for i=1,6 do if GYBARSINIT[i]==1 then getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.6,.2,.2) getglobal("GYBARST"..i.."x"):Show()
			else getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.4,.4,.4) getglobal("GYBARST"..i.."x"):Hide() end end end
	if englishFaction=="Alliance" then
		for i=1,6 do if GYBARSINIT[i]==1 then getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.2,.2,.6) getglobal("GYBARST"..i.."x"):Show()
			else getglobal("GYBARS_T"..i.."_Back"):SetVertexColor(.4,.4,.4) getglobal("GYBARST"..i.."x"):Hide() end end end


elseif GetZoneText()=="Warsong Gulch" then
	if string.find(arg1,GYBARS["begin"]) then for i=1,8 do GYBARSTARGETS[i]=GetBattlefieldInstanceRunTime()/1000+GYBARS["DEFAULTDURATION"] end end
	GYBARSINIT[1]=1
end 
	
end

function GYBARS_minDist()
	myX,myY=GetPlayerMapPosition("Player")
	englishFaction, localizedFaction = UnitFactionGroup("Player")
	if GetZoneText()=="Alterac Valley" then
		tempv ={}
		for i=1,7 do tempv[i]=math.sqrt((GYBARSAVX[i]-myX)*(GYBARSAVX[i]-myX)+(GYBARSAVY[i]-myY)*(GYBARSAVY[i]-myY)) end

		if englishFaction=="Horde" then tempv[8]=math.sqrt((GYBARSAVX[9]-myX)*(GYBARSAVX[9]-myX)+(GYBARSAVY[9]-myY)*(GYBARSAVY[9]-myY)) end
		if englishFaction=="Alliance" then tempv[8]=math.sqrt((GYBARSAVX[8]-myX)*(GYBARSAVX[8]-myX)+(GYBARSAVY[8]-myY)*(GYBARSAVY[8]-myY)) end

		minindex=8 minval=tempv[8]
		for i=1,7 do if tempv[i]<minval and GYBARSINIT[i]==1 then minval=tempv[i] minindex=i end end
		GYBARS_Location:SetPoint("LEFT",-12,13*(minindex-1))
		if minindex==8 then GYBARS_Location:SetPoint("LEFT",-12,-13) end
		GYBARS["CurrentGY"]=minindex
	elseif GetZoneText()=="Arathi Basin" then
		tempv ={}
		for i=1,5 do tempv[i]=math.sqrt((GYBARSABX[i]-myX)*(GYBARSABX[i]-myX)+(GYBARSABY[i]-myY)*(GYBARSABY[i]-myY)) end

		if englishFaction=="Horde" then tempv[6]=math.sqrt((GYBARSABX[7]-myX)*(GYBARSABX[7]-myX)+(GYBARSABY[7]-myY)*(GYBARSABY[7]-myY)) end
		if englishFaction=="Alliance" then tempv[6]=math.sqrt((GYBARSABX[6]-myX)*(GYBARSABX[6]-myX)+(GYBARSABY[6]-myY)*(GYBARSABY[6]-myY)) end

		minindex=6 minval=tempv[6]
		for i=1,5 do if tempv[i]<minval and GYBARSINIT[i]==1 then minval=tempv[i] minindex=i end end
		GYBARS_Location:SetPoint("LEFT",-12,13*(minindex-1))
		if minindex==6 then GYBARS_Location:SetPoint("LEFT",-12,-13) end
		GYBARS["CurrentGY"]=minindex
	elseif GetZoneText()=="Warsong Gulch" then
		GYBARS["CurrentGY"]=1
	end
end

function GYBARS_EnterGY()
--Determine at which GY you have spawned

if GetZoneText()=="Alterac Valley" then
	GYBARS_minDist()	
	GYBARS["OLDTIME"]=0
elseif GetZoneText()=="Arathi Basin" then
	GYBARS_minDist()
	GYBARS["OLDTIME"]=0
elseif GetZoneText()=="Warsong Gulch" then
	GYBARS["OLDTIME"]=0
end



end

----------------------
-- Event Handler
-- this function parses events
function GYBARS_OnEvent()

	if event=="VARIABLES_LOADED" then GYBARS_Initialize() end
	if event=="PLAYER_ENTERING_WORLD" then GYBARS_Zone() end
	if event=="AREA_SPIRIT_HEALER_IN_RANGE" then GYBARS_EnterGY() end
	if event=="CHAT_MSG_BG_SYSTEM_ALLIANCE" or event=="CHAT_MSG_BG_SYSTEM_HORDE" 
		or event=="CHAT_MSG_BG_SYSTEM_NEUTRAL" or event=="CHAT_MSG_MONSTER_YELL" then GYBARS_UpdateControl() end
	if event=="CHAT_MSG_ADDON" then GYBARS_ChatCatch() end

end


function GYBARS_Zone()
	for i=1,8 do GYBARSINIT[i]=0 end
	GYBARS_UpdateControl()
	if GetZoneText()=="Alterac Valley" then
		for i=1,7 do getglobal("GYBARST"..i.."y"):SetText(GYBARSAV[i]) end
		englishFaction, _ = UnitFactionGroup("Player")
		if englishFaction=="Horde" then GYBARST8y:SetText(GYBARSAV[9]) end
		if englishFaction=="Alliance" then GYBARST8y:SetText(GYBARSAV[8]) end
		GYBARS_Frame:Show()
	elseif GetZoneText()=="Warsong Gulch" then
		englishFaction, _ = UnitFactionGroup("Player")
		if englishFaction=="Horde" then GYBARST1y:SetText(GYBARSWSG[2]) GYBARS_T1_Back:SetVertexColor(.6,.2,.2) end
		if englishFaction=="Alliance" then GYBARST1y:SetText(GYBARSWSG[1]) GYBARS_T1_Back:SetVertexColor(.2,.2,.6) end
		GYBARSINIT[1]=1
		GYBARS_Frame:Show()
	elseif GetZoneText()=="Arathi Basin" then
		for i=1,5 do getglobal("GYBARST"..i.."y"):SetText(GYBARSAB[i]) end
		englishFaction, _ = UnitFactionGroup("Player")
		if englishFaction=="Horde" then GYBARST6y:SetText(GYBARSAB[7]) end
		if englishFaction=="Alliance" then GYBARST6y:SetText(GYBARSAV[6]) end
		GYBARS_Frame:Show()
	else
		GYBARS_Frame:Hide()
	end
	
end

function GYBARS_Slash(garg1)


end
